import { State } from "./lib/savedstate";
import { Datapoint, ParamType } from "./types";
export interface ParamDef {
    create_d3_scale: any;
    type: ParamType;
    optional: boolean;
    numeric: boolean;
    distinct_values: Array<any>;
    colorScheme: (value: any, alpha: number) => string;
    colors: object;
    special_values: Array<any>;
    type_options: Array<ParamType>;
    __url_state__: State;
}
export interface ParamDefMap {
    [key: string]: ParamDef;
}
/**
 * Ideally we want to infer:
 *  - If a variable is categorical
 *  - If a variable is numeric
 *  - If a variable is log-scaled
 */
export declare function infertypes(url_states: State, table: Array<Datapoint>, hints: any): ParamDefMap;
